var currentLongUrl = null,
    isQRRequired = false,
    senderId = null;

// Send message to content script
chrome.browserAction.onClicked.addListener(function () {
   chrome.tabs.query({
      active: true,
      currentWindow: true
   }, function (tabs) {
      chrome.tabs.sendMessage(tabs[0].id, {
         action: "toggle-text-area"
      }, null);
   });
});

chrome.runtime.onMessage.addListener(
   function (request, sender, sendResponse) {
      if (request.action === "generator_requestLongURL") {
         getLongURL(request, sender, sendResponse);
      } else if (request.action === "generator_responseShortURL") {
         receiveShortURL(request, sender, sendResponse);
      } else if (request.action === "requestLongURL") {
         requestLongURL(request, sender, sendResponse);
      }
   });

/////////////////////

function requestLongURL(request, sender, sendResponse) {
   currentLongUrl = request.data.longURL;
   isQRRequired = request.data.isQRRequired;
   senderId = sender.tab.id;
   
   chrome.tabs.create({
      url: chrome.extension.getURL('generator.html'),
      active: false
   });
}

function getLongURL(request, sender, sendResponse) {
   sendResponse({
      longURL: currentLongUrl
   });
}

function receiveShortURL(request, sender, sendResponse) {
   console.log("receiveShortURL: " + request.data.shortURL);
   var messageToContentScripts = {
      action: "responseShortURL",
      data: {
         shortUrl: request.data.shortURL,
         isQRRequired: isQRRequired
      }
   };
   
   chrome.tabs.sendMessage(senderId, messageToContentScripts);
}