console.log('dfg');

var listener = new window.keypress.Listener();
var enterKey = 13,
   user_input = [],
   adjustTextWidth,
   suggestionsEnabled;

chrome.runtime.onMessage.addListener(
   function (request, sender, sendResponse) {
      if (request.action === "responseShortURL") {
         showShortUrl(request.data.shortUrl, request.data.isQRRequired);
      }
   });

// Determine if Enter & Shift are pressed
listener.simple_combo("enter shift", function () {

   // Create line break
   $('#user_input').val($('#user_input').val() + "\n");

});

function showShortUrl(shortenUrl, isQRRequired) {
   $('<div id="usertext">').appendTo('body').html('<p class="shorten-url">' + shortenUrl + '</p>');
   updateFontSize(isQRRequired);
   
   if (isQRRequired) {
      $("#usertext").css({
         'vertical-align': 'top',
         'bottom': '10%'
      });
      
      $('<div id="qrContainer">').appendTo('#usertext');
      
      var popupHeight = $("#usertext").height();
      var shortenHeight = $("#usertext .shorten-url").height();
      var qrHeight = popupHeight - shortenHeight;
   
      var qrcode = new QRCode(document.getElementById("qrContainer"), {
          text: shortenUrl,
          width: qrHeight,
          height: qrHeight,
          colorDark : "#000000",
          colorLight : "#ffffff",
          correctLevel : QRCode.CorrectLevel.H
      });
   }
}


$(document).on('keydown', function (e) {

   // Determine if Enter key is pressed
   if (e.keyCode == enterKey && !e.shiftKey) {

      // Hide textarea & show enlarged text
      hideTextArea();

      listener.stop_listening();
   }

});

$(document).on('click', '#CraftyTextShortenURL', function (e) {
   generateShortURL(e, false);
});

function generateShortURL(e, isQRRequired) {
      e.preventDefault();
   e.stopPropagation();

   
   
   var UI = $('#user_input').val().trim();
//   if (UI != undefined) {
//      user_input.unshift(UI);
//   }
//   var user_input = _.uniq(user_input);
//   if (!user_input || !user_input.length || !user_input[0]) {
//      return;
//   }
//   
//   user_input = user_input[0];
   hideTextArea(true);
   
   var requestMessage = {
      action: "requestLongURL",
      data: {
         longURL: UI,
         isQRRequired: isQRRequired
      }
   };

   chrome.runtime.sendMessage(requestMessage);
}

$(document).on('click', '#CraftyTextQRCode', function (e) {
   generateShortURL(e, true);
})


$(document).on('click', '#CraftyTextDisplayBtn', function (e) {
   e.preventDefault();
   e.stopPropagation();
   hideTextArea();
})

function hideTextArea(preventTextView) {
   UI = $('#user_input').val().trim();
   adjustTextWidth = $('#craftytext-checkbox').is(':checked');

   if (UI != undefined) {
      user_input.unshift(UI);
   }

   user_input = _.uniq(user_input);

   $('#craftytext-suggests-checkbox').unbind('change', suggestCheckChanged);
   unbindAutocomplete();
   $('#textbox').remove();
   if ($('#usertext').length) {
      $('#usertext').remove();
   } else {
      if (!preventTextView && user_input[0] != undefined) {
         $('<div id="usertext">').appendTo('body').html('<p>' + user_input[0] + '</p>');
         updateFontSize();
      }
   }
}

function displayTextArea() {
   if ($('#textbox').length == 0) {
      $('<div id="textbox" class="craftytext">').appendTo('body').html('<textarea id="user_input"></textarea>');
      var textBlock = $('#textbox');

      $('<div id="ct-checkbox">' +
         '<label><input type="checkbox" id="craftytext-checkbox" checked>Adapt text size</label>' +
         '</div>').appendTo(textBlock);

      var isSuggestionsChecked = suggestionsEnabled ? "checked" : "";
      $('<div id="ct-suggests-checkbox">' +
         '<label><input type="checkbox" id="craftytext-suggests-checkbox" ' + isSuggestionsChecked +
         '>Show suggestions</label>' +
         '</div>').appendTo(textBlock);

      $('<div class="craftyText_shortenBlock">' +
        '<button id="CraftyTextDisplayBtn">Display</button>' +
         '<button id="CraftyTextShortenURL">Shorten</button>' +
        '<button id="CraftyTextQRCode">Shorten w/ QR</button>' +
         '</div>').appendTo(textBlock);

      $('#craftytext-suggests-checkbox').change(suggestCheckChanged);
      setupAutocomplete();
      suggestCheckChanged.call($('#craftytext-suggests-checkbox')[0]);
      //      suggestCheckChanged();

      $('#user_input').focus();
   }
   if ($('#usertext').length) {
      $('#usertext').remove();
   }
}

function suggestCheckChanged() {
   var isChecked = $(this).is(":checked");
   console.log("check changed: " + isChecked);
   suggestionsEnabled = isChecked;
   var $input = $("#user_input");
   isChecked ? $input.autocomplete("enable") : $input.autocomplete("disable")
}

function updateFontSize(isQRRequired) {
   if (adjustTextWidth) {
      getFontFromAdjustingWidth(isQRRequired);
   } else {
      getFontFromTextLength(isQRRequired);
   }
}

function getFontFromTextLength(isQRRequired) {
   $("#usertext .shorten-url").css('font-size', function () {
      var $numWords = $(this).text().length; // get length of text for current p element
      if (($numWords >= 1) && ($numWords < 20)) {
         return "160px"
      } else if (($numWords >= 20) && ($numWords < 60)) {
         return "140px";
      } else if (($numWords >= 60) && ($numWords < 100)) {
         return "120px";
      } else {
         return "80px";
      }
   });
}

function getFontFromAdjustingWidth(isQRRequired) {
   console.log('ra');
   var textBlockHeight = $("#usertext").height();
   $("#usertext").css('bottom', '10%');
   textBlockHeight = $("#usertext").height();
   var stringToDisplay = $("#usertext .shorten-url").text();

   stringToDisplay = stringToDisplay.replace(/(\r\n|\n|\r)/gm, "");
   $("#usertext .shorten-url").text(stringToDisplay);

   var textBlockWidth = $("#usertext").width() - 20;
   textBlockHeight = $("#usertext").height();

   var sizeCounter = 1;
   var font = formatFontString(sizeCounter);
   var textWidth = getTextWidth(stringToDisplay, font);
   //   var textHeight = getTextHeight(stringToDisplay, font);

   textHeight = sizeCounter;
   while (textBlockWidth > textWidth && (textBlockHeight * 0.8) > textHeight) {
      sizeCounter++;
      font = formatFontString(sizeCounter);
      textWidth = getTextWidth(stringToDisplay, font);
      //      textHeight = getTextHeight(stringToDisplay, font);
      textHeight = sizeCounter;
   }

   sizeCounter--;
   var textLineHeight = textBlockWidth > textWidth ? sizeCounter : textBlockHeight * 0.8;

   $("#usertext .shorten-url").css('font-size', sizeCounter.toString() + 'px');
   if (!isQRRequired) {
      $("#usertext .shorten-url").css('line-height', textLineHeight.toString() + 'px');
   }
   

}

function formatFontString(size) {
   return 'bold ' + size + 'px Arial, sans-serif';
}

function getTextWidth(text, font) {
   // re-use canvas object for better performance
   var canvas = getTextWidth.canvas || (getTextWidth.canvas = document.createElement("canvas"));
   var context = canvas.getContext("2d");
   context.font = font;
   var metrics = context.measureText(text);
   return metrics.width;
};

function getTextHeight(text, font) {
   // re-use canvas object for better performance
   var canvas = getTextWidth.canvas || (getTextWidth.canvas = document.createElement("canvas"));
   var context = canvas.getContext("2d");
   context.font = font;
   var metrics = context.measureText(text);
   return metrics.height;
};

function hideAll() {
   if ($('#usertext').length) {
      $('#usertext').remove();
   }
   if ($('#textbox').length) {
      $('#textbox').remove();
   }
}

//////////////////////


function setupAutocomplete() {
   function split(val) {
      return val.split(' ');
   }

   function extractLast(term) {
      return split(term).pop();
   }
   $("#user_input")
      // don't navigate away from the field on tab when selecting an item
      .bind("keydown", userInputKeydown)
      .autocomplete({
         minLength: 1,
         appendTo: '#textbox',
         source: function (request, response) {
            // delegate back to autocomplete, but extract the last term
            var term = extractLast(request.term);
            if (term.length >= 1) {
               response($.ui.autocomplete.filter(user_input, term));
            }
         },
         focus: function () {
            // prevent value inserted on focus
            return false;
         },
         select: function (event, ui) {
            var terms = split(this.value);
            // remove the current input
            terms.pop();
            // add the selected item
            terms.push(ui.item.value);
            // add placeholder to get the comma-and-space at the end
            terms.push("");
            this.value = terms.join(" ");
            return false;
         }
      });
}

function userInputKeydown(event) {
   if (event.keyCode === $.ui.keyCode.TAB && $(this).data("ui-autocomplete").menu.active) {
      event.preventDefault();
   }
}

function unbindAutocomplete() {
   $("#user_input").unbind("keydown", userInputKeydown).autocomplete("destroy");
}

///////////////////////

// Receive message from background script (browser action)
chrome.runtime.onMessage.addListener(
   function (request, sender, sendResponse) {
      if (request.action == "toggle-text-area") {

         if ($('#usertext').length || $('#textbox').length) {
            // textarea or enlarged text are showed

            hideAll();

            listener.stop_listening();

         } else {

            listener.listen();

            displayTextArea();
         }
      }
   });